diff --git a/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
index 38bb40bb9..8f350b750 100644
--- a/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/LoginPacketHandler.java
@@ -1,38 +1,44 @@
 package net.minecraft.server.net.handler;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.net.handler.PacketHandler;
+import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.*;
-import net.minecraft.server.net.thread.ThreadLoginVerifier;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.RSA;
 import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.server.MinecraftServer;
-import org.apache.log4j.Logger;
-
+import org.slf4j.Logger;
 
+import java.io.BufferedReader;
 import java.io.IOException;
+import java.io.InputStreamReader;
 import java.net.Socket;
+import java.net.URL;
+import java.net.URLEncoder;
 import java.security.Key;
 import java.util.Random;
-
-
-// Referenced classes of package net.minecraft.src:
-//            PacketHandler, NetworkManager, DisconnectPacket, PreLoginPacket,
-//            LoginPacket, ThreadLoginVerifier, ServerConfigurationManager, ServerPlayer,
-//            WorldServer, ServerPacketHandler, WorldProvider, SetSpawnPositionPacket,
-//            ChunkCoordinates, ChatPacket, NetworkListenThread, SetTimePacket,
-//            Packet
+import java.util.UUID;
 
 public class LoginPacketHandler extends PacketHandler
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final Random rand = new Random();
+    public NetworkManager netManager;
+    public boolean finishedProcessing;
+    private final MinecraftServer mcServer;
+    private int loginTimer;
+    private String username;
+    private LoginPacket loginPacket;
+    private String serverId;
     public static String kickMessage = null;
 
     public LoginPacketHandler(MinecraftServer minecraftserver, Socket socket, String s)
@@ -74,14 +80,14 @@ public class LoginPacketHandler extends PacketHandler
     {
         try
         {
-            if (!silent) logger.info("Disconnecting " + getUserAndIPString() + ": " + s);
+            if (!silent) LOGGER.info("Disconnecting {}: {}", getUserAndIPString(), s);
             netManager.addToSendQueue(new DisconnectPacket(s));
             netManager.serverShutdown();
             finishedProcessing = true;
         }
         catch (Exception exception)
         {
-            exception.printStackTrace();
+            LOGGER.error("Error while kicking user '{}'!", s, exception);
         }
     }
 
@@ -121,69 +127,104 @@ public class LoginPacketHandler extends PacketHandler
         }
         else
         {
-            (new ThreadLoginVerifier(this, loginPacket)).start();
+            new Thread(
+                () -> {
+                    try
+                    {
+                        String s = LoginPacketHandler.getServerId(this);
+                        URL url = new URL("http://session.minecraft.net/game/checkserver.jsp?user=" + URLEncoder.encode(loginPacket.username, "UTF-8") + "&serverId=" + URLEncoder.encode(s, "UTF-8"));
+                        BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(url.openStream()));
+                        String s1 = bufferedreader.readLine();
+                        bufferedreader.close();
+                        if(s1.equals("YES"))
+                        {
+                            LoginPacketHandler.setLoginPacket(this, loginPacket);
+                        } else
+                        {
+                            this.kickUser("Failed to verify username!");
+                        }
+                    }
+                    catch(Exception exception)
+                    {
+                        LOGGER.error("Exception while trying to verify user '{}', kicking!", this.getUserAndIPString(), exception);
+                        this.kickUser("Failed to verify username! [internal error " + exception + "]");
+                    }
+                }
+            ).start();
         }
     }
 
     public void doLogin(LoginPacket loginPacket)
     {
-        ServerPlayer entityplayermp = mcServer.playerList.getPlayerForLogin(this, loginPacket.username);
-        if (entityplayermp != null)
+        if (mcServer.onlineMode) {
+            UUID mojangUUID = UUIDHelper.getUUIDFromName(loginPacket.username);
+            if (mojangUUID == null) {
+                kickUser("Cannot authenticate UUID!");
+                return;
+            }
+            if (!mojangUUID.equals(loginPacket.uuid)) {
+                kickUser("UUID mismatch!");
+                return;
+            }
+        }
+        ServerPlayer player = mcServer.playerList.getPlayerForLogin(this, loginPacket.username, loginPacket.uuid);
+        if (player != null)
         {
-            mcServer.playerList.load(entityplayermp);
-            entityplayermp.setWorld(mcServer.getDimensionWorld(entityplayermp.dimension));
-            logger.info(getUserAndIPString() + " logged in with entity id " + entityplayermp.id + " at (" + entityplayermp.x + ", " + entityplayermp.y + ", " + entityplayermp.z + ")");
-            WorldServer worldserver = mcServer.getDimensionWorld(entityplayermp.dimension);
+            mcServer.playerList.load(player);
+            player.setWorld(mcServer.getDimensionWorld(player.dimension));
+            LOGGER.info(getUserAndIPString() + " logged in with entity id " + player.id + " at (" + player.x + ", " + player.y + ", " + player.z + ")");
+            WorldServer worldserver = mcServer.getDimensionWorld(player.dimension);
             ChunkCoordinates chunkcoordinates = worldserver.getSpawnPoint();
-            ServerPacketHandler netserverhandler = new ServerPacketHandler(mcServer, netManager, entityplayermp);
+            ServerPacketHandler packetHandler = new ServerPacketHandler(mcServer, netManager, player);
             try
             {
-                netserverhandler.sendPacket(new LoginPacket("", entityplayermp.id, worldserver.getRandomSeed(), (byte) worldserver.dimension.id, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver.dimensionData.getWorldType()), NetworkManager.PACKET_DELAY, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
+                packetHandler.sendPacket(new LoginPacket("", new UUID(0, 0), player.id, worldserver.getRandomSeed(), (byte) worldserver.dimension.id, (byte) Registries.WORLD_TYPES.getNumericIdOfItem(worldserver.dimensionData.getWorldType()), NetworkManager.PACKET_DELAY, RSA.getPublicKey(RSA.RSAKeyChain.getPublic())));
 
                 Key aesKey = AES.generateKey();
-                netserverhandler.sendPacket(new AESSendKeyPacket(RSA.encrypt(AES.getKey(aesKey), RSA.getPublicKey(loginPacket.publicKey))));
-                AES.keyChain.put(entityplayermp.username, aesKey);
+                packetHandler.sendPacket(new AESSendKeyPacket(RSA.encrypt(AES.getKey(aesKey), RSA.getPublicKey(loginPacket.publicKey))));
+                AES.keyChain.put(player.username, aesKey);
             }
             catch (Exception e)
             {
                 throw new RuntimeException(e);
             }
 
-            netserverhandler.sendPacket(new SetSpawnPositionPacket(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z));
-            mcServer.playerList.func_28170_a(entityplayermp, worldserver);
-            mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(TextFormatting.YELLOW + entityplayermp.getDisplayName() + TextFormatting.YELLOW + " joined the game."));
-            mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(entityplayermp.username, entityplayermp.nickname, entityplayermp.score, entityplayermp.chatColor, true, entityplayermp.isOperator()));
+            packetHandler.sendPacket(new SetSpawnPositionPacket(chunkcoordinates.x, chunkcoordinates.y, chunkcoordinates.z));
+            mcServer.playerList.func_28170_a(player, worldserver);
+            mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(TextFormatting.YELLOW + player.getDisplayName() + TextFormatting.YELLOW + " joined the game."));
+            mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
 
-            if (mcServer.joinMessage != null && mcServer.joinMessage.length() > 0)
+            if (mcServer.joinMessage != null && !mcServer.joinMessage.isEmpty())
             {
-                entityplayermp.playerNetServerHandler.sendPacket(new ChatPacket(mcServer.joinMessage));
+                player.playerNetServerHandler.sendPacket(new ChatPacket(mcServer.joinMessage));
             }
 
-            mcServer.playerList.playerLoggedIn(entityplayermp);
-            netserverhandler.teleportAndRotate(entityplayermp.x, entityplayermp.y, entityplayermp.z, entityplayermp.yRot, entityplayermp.xRot);
-            mcServer.networkServer.addPlayer(netserverhandler);
-            mcServer.playerList.sendPacketToAllPlayers(new PlayerGamemodePacket(entityplayermp.id, entityplayermp.gamemode.getId()));
-            netserverhandler.sendPacket(new SetTimePacket(worldserver.getWorldTime()));
-            entityplayermp.func_20057_k();
+            mcServer.playerList.playerLoggedIn(player);
+            packetHandler.teleportAndRotate(player.x, player.y, player.z, player.yRot, player.xRot);
+            mcServer.networkServer.addPlayer(packetHandler);
+            mcServer.playerList.sendPacketToAllPlayers(new PlayerGamemodePacket(player.id, player.gamemode.getId()));
+            packetHandler.sendPacket(new SetTimePacket(worldserver.getWorldTime()));
+            player.func_20057_k();
             if (MinecraftServer.statsStatus)
             {
                 RestHandler.post("https://api.betterthanadventure.net/stats?serverToken=" + MinecraftServer.statsToken + "&count=" + mcServer.playerList.playerEntities.size());
             }
-            entityplayermp.playerNetServerHandler.sendPacket(new PhotoModePacket(mcServer.disablePhotoMode));
-            entityplayermp.playerNetServerHandler.sendPacket(new GameRulePacket(mcServer.getDimensionWorld(0).getLevelData().getGameRules()));
+            player.playerNetServerHandler.sendPacket(new PhotoModePacket(mcServer.disablePhotoMode));
+            player.playerNetServerHandler.sendPacket(new GameRulePacket(mcServer.getDimensionWorld(0).getLevelData().getGameRules()));
 
             for (RecipeEntryBase<?, ?, ?> recipe : Registries.RECIPES.getAllSerializableRecipes()) {
-                entityplayermp.playerNetServerHandler.sendPacket(new RecipeSyncPacket(recipe,Registries.RECIPES.getAllSerializableRecipes().size()));
+                player.playerNetServerHandler.sendPacket(new RecipeSyncPacket(recipe,Registries.RECIPES.getAllSerializableRecipes().size()));
             }
-            entityplayermp.playerNetServerHandler.sendPacket(new SyncIDsPacket());
+            player.playerNetServerHandler.sendPacket(new SyncIDsPacket());
         }
         finishedProcessing = true;
     }
 
     @Override
-	public void handleErrorMessage(String s, Object aobj[])
+	public void handleErrorMessage(String message, Object[] objects)
     {
-        logger.info(getUserAndIPString() + " lost connection");
+        LOGGER.info("{} lost connection", getUserAndIPString());
+        LOGGER.error(message, objects);
         finishedProcessing = true;
     }
 
@@ -249,24 +290,13 @@ public class LoginPacketHandler extends PacketHandler
         return true;
     }
 
-    public static String getServerId(LoginPacketHandler netloginhandler)
+    public static String getServerId(LoginPacketHandler loginPacketHandler)
     {
-        return netloginhandler.serverId;
+        return loginPacketHandler.serverId;
     }
 
-    public static LoginPacket setLoginPacket(LoginPacketHandler netloginhandler, LoginPacket loginPacket)
+    public static LoginPacket setLoginPacket(LoginPacketHandler loginPacketHandler, LoginPacket loginPacket)
     {
-        return netloginhandler.loginPacket = loginPacket;
+        return loginPacketHandler.loginPacket = loginPacket;
     }
-
-    public static Logger logger = Logger.getLogger("Minecraft");
-    private static Random rand = new Random();
-    public NetworkManager netManager;
-    public boolean finishedProcessing;
-    private MinecraftServer mcServer;
-    private int loginTimer;
-    private String username;
-    private LoginPacket loginPacket;
-    private String serverId;
-
 }
diff --git a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
index 4b2550d1f..413f87bc7 100644
--- a/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
+++ b/src/main/java/net/minecraft/server/net/handler/ServerPacketHandler.java
@@ -1,5 +1,6 @@
 package net.minecraft.server.net.handler;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
@@ -67,7 +68,7 @@ import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.ServerPlayer;
 import net.minecraft.server.util.helper.PlayerList;
 import net.minecraft.server.world.WorldServer;
-import org.apache.log4j.Logger;
+import org.slf4j.Logger;
 
 import java.nio.charset.StandardCharsets;
 import java.util.ArrayList;
@@ -82,7 +83,7 @@ public class ServerPacketHandler extends PacketHandler
     {
         connectionClosed = false;
         hasMoved = true;
-        field_10_k = new HashMap();
+        guiIdMap = new HashMap<>();
         mcServer = minecraftserver;
         netManager = networkManager;
         networkManager.setNetHandler(this);
@@ -106,7 +107,7 @@ public class ServerPacketHandler extends PacketHandler
         sendPacket(new DisconnectPacket(s));
         netManager.serverShutdown();
         mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " was kicked from the game."));
-        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
+        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
         mcServer.playerList.playerLoggedOut(playerEntity);
         connectionClosed = true;
         if (MinecraftServer.statsStatus)
@@ -211,10 +212,6 @@ public class ServerPacketHandler extends PacketHandler
             {
                 packet.hasPosition = false;
             }
-            if (packet.hasPosition && packet.y == -999D && packet.yView == -999D)
-            {
-                packet.hasPosition = false;
-            }
             if (packet.hasPosition)
             {
                 newPosX = packet.x;
@@ -231,7 +228,7 @@ public class ServerPacketHandler extends PacketHandler
                 if (java.lang.Math.abs(packet.x) > 32000000D || java.lang.Math.abs(packet.z) > 32000000D)
                 {
 //                    kickPlayer("Illegal position");
-                    logger.warn((new StringBuilder()).append(playerEntity.username).append(" tried to move to an illegal position").toString());
+                    LOGGER.warn("{} tried to move to an illegal position", playerEntity.username);
                     teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
                     return;
                 }
@@ -255,7 +252,7 @@ public class ServerPacketHandler extends PacketHandler
             // Lag back the player if they move too quickly
             if (velSquared > 100D)
             {
-                logger.warn(playerEntity.username + " moved too quickly!");
+                LOGGER.warn("{} moved too quickly!", playerEntity.username);
                 teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
 //                kickPlayer("You moved too quickly :( (Hacking?)");
                 return;
@@ -275,9 +272,9 @@ public class ServerPacketHandler extends PacketHandler
             if (!playerEntity.getGamemode().canPlayerFly() && velSquared > 0.0625D && !playerEntity.isPlayerSleeping())
             {
                 flag1 = true;
-                logger.warn(playerEntity.username + " moved wrongly!");
-                System.out.println("Got position " + newPosX + ", " + newPosY + ", " + newPosZ);
-                System.out.println("Expected " + playerEntity.x + ", " + playerEntity.y + ", " + playerEntity.z);
+                LOGGER.warn("{} moved wrongly!", playerEntity.username);
+                LOGGER.warn("Got position {}, {}, {}", newPosX, newPosY, newPosZ);
+                LOGGER.warn("Expected {}, {}, {}", playerEntity.x, playerEntity.y, playerEntity.z);
             }
             playerEntity.absMoveTo(newPosX, newPosY, newPosZ, f2, f3);
             boolean flag2 = worldserver.getCubes(playerEntity, playerEntity.bb.copy().getInsetBoundingBox(f4, f4, f4)).size() == 0;
@@ -286,14 +283,14 @@ public class ServerPacketHandler extends PacketHandler
                 teleportAndRotate(lastPosX, lastPosY, lastPosZ, f2, f3);
                 return;
             }
-            AABB axisalignedbb = playerEntity.bb.copy().grow(f4, f4, f4).expand(0.0D, -0.55D, 0.0D);
-            if (!playerEntity.getGamemode().canPlayerFly() && !mcServer.allowFlight && !worldserver.getIsAnySolidGround(axisalignedbb))
+            AABB aabb = playerEntity.bb.copy().grow(f4, f4, f4).expand(0.0D, -0.55D, 0.0D);
+            if (!playerEntity.getGamemode().canPlayerFly() && !mcServer.allowFlight && !worldserver.getIsAnySolidGround(aabb))
             {
                 if (dy > -0.03125D)
                 {
                     playerInAirTime++;
                     if (playerInAirTime > 100) {
-                        logger.warn(playerEntity.username + " was kicked for floating too long!");
+                        LOGGER.warn(playerEntity.username + " was kicked for floating too long!");
                         kickPlayer("Flying is not enabled on this server");
                         return;
                     } else if (playerInAirTime > 80)
@@ -363,7 +360,7 @@ public class ServerPacketHandler extends PacketHandler
         }
 
         // Check spawn protection
-        boolean ignoreSpawnProtection = world.field_819_z = mcServer.spawnProtectionRange <= 0 || world.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.username);
+        boolean ignoreSpawnProtection = world.field_819_z = mcServer.spawnProtectionRange <= 0 || world.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
         ChunkCoordinates spawnPos = world.getSpawnPoint();
         int spawnDistX = (int) MathHelper.abs(x - spawnPos.x);
         int spawnDistZ = (int) MathHelper.abs(z - spawnPos.z);
@@ -392,9 +389,9 @@ public class ServerPacketHandler extends PacketHandler
 
     public void handleSendInitialPlayerList()
     {
-        for (ServerPlayer entityPlayerServer : mcServer.playerList.playerEntities)
+        for (ServerPlayer serverPlayer : mcServer.playerList.playerEntities)
         {
-            sendPacket(new UpdatePlayerProfilePacket(entityPlayerServer.username, entityPlayerServer.nickname, entityPlayerServer.score, entityPlayerServer.chatColor, true, entityPlayerServer.isOperator()));
+            sendPacket(new UpdatePlayerProfilePacket(serverPlayer.username, serverPlayer.nickname, serverPlayer.uuid, serverPlayer.score, serverPlayer.chatColor, true, serverPlayer.isOperator()));
         }
     }
 
@@ -404,7 +401,7 @@ public class ServerPacketHandler extends PacketHandler
         if (!playerEntity.getGamemode().canInteract() || !playerEntity.isAlive()) return;
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         ItemStack itemstack = playerEntity.inventory.getCurrentItem();
-        boolean flag = worldserver.field_819_z = worldserver.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.username);
+        boolean flag = worldserver.field_819_z = worldserver.dimension.id != 0 || mcServer.playerList.isOp(playerEntity.uuid);
         if (packet.direction == Direction.NONE)
         {
             if (itemstack == null)
@@ -458,9 +455,9 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleErrorMessage(String s, Object[] aobj)
     {
-        logger.info(playerEntity.username + " lost connection: " + s);
+        LOGGER.info(playerEntity.username + " lost connection: " + s);
         mcServer.playerList.sendPacketToAllPlayers(new ChatPacket(playerEntity.getDisplayName() + TextFormatting.YELLOW + " left the game."));
-        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
+        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(playerEntity.username, playerEntity.nickname, playerEntity.uuid, playerEntity.score, playerEntity.chatColor, false, playerEntity.isOperator()));
         mcServer.playerList.playerLoggedOut(playerEntity);
         connectionClosed = true;
         if (MinecraftServer.statsStatus)
@@ -473,7 +470,7 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleInvalidPacket(Packet packet)
     {
-        logger.warn(getClass() + " wasn't prepared to deal with a " + packet.getClass());
+        LOGGER.warn(getClass() + " wasn't prepared to deal with a " + packet.getClass());
         kickPlayer("Protocol error, unexpected packet");
     }
 
@@ -488,7 +485,7 @@ public class ServerPacketHandler extends PacketHandler
     {
         if (packet.id < 0 || packet.id > Inventory.func_25054_e())
         {
-            logger.warn(playerEntity.username + " tried to set an invalid carried item");
+            LOGGER.warn(playerEntity.username + " tried to set an invalid carried item");
             return;
         }
         else
@@ -516,7 +513,7 @@ public class ServerPacketHandler extends PacketHandler
 		}
 		
 		message = message.trim();
-//		message = message.replace('\u00A7', '$');
+//		message = message.replace('§', '$');
 		
 		for(int i = 0; i < message.length(); i++) {
 			char c = message.charAt(i);
@@ -531,7 +528,7 @@ public class ServerPacketHandler extends PacketHandler
 		}else {
 			message = ChatEmotes.process(message);
 			message = "<" + playerEntity.getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + message;
-			logger.info(message);
+			LOGGER.info(message);
 			mcServer.playerList.sendEncryptedChatToAllPlayers(message);
 		}
 	}
@@ -551,12 +548,12 @@ public class ServerPacketHandler extends PacketHandler
             {
                 if (!sender.isAdmin() && command.opRequired(args1))
                 {
-                    logger.info("Player " + sender.getPlayer().username + " tried command: " + s);
+                    LOGGER.info("Player {} tried command: {}", sender.getPlayer().username, s);
                     sender.sendMessage(TextFormatting.RED + "You don't have permission to use this command!");
                     return;
                 }
 
-                logger.info("Player " + sender.getPlayer().username + " used command: " + s);
+                LOGGER.info("Player {} used command: {}", sender.getPlayer().username, s);
                 try
                 {
                     boolean success = command.execute(handler, sender, args1);
@@ -571,7 +568,7 @@ public class ServerPacketHandler extends PacketHandler
                 }
                 catch (Throwable e)
                 {
-                    e.printStackTrace();
+                    LOGGER.error("Exception while trying to perform command '{}'!", s, e);
                     sender.sendMessage(TextFormatting.RED + "Error!");
                 }
                 return;
@@ -632,7 +629,7 @@ public class ServerPacketHandler extends PacketHandler
     }
 
     @Override
-    public void log(String s)
+    public void logInfo(String s)
     {
         sendPacket(new ChatPacket("\2477" + s));
     }
@@ -725,7 +722,7 @@ public class ServerPacketHandler extends PacketHandler
             }
             else
             {
-                field_10_k.put(Integer.valueOf(playerEntity.craftingInventory.containerId), Short.valueOf(packet.actionId));
+                guiIdMap.put(playerEntity.craftingInventory.containerId, packet.actionId);
                 playerEntity.playerNetServerHandler.sendPacket(new ContainerAckPacket(packet.window_Id, packet.actionId, false));
                 playerEntity.craftingInventory.setSynched(playerEntity, false);
                 ArrayList<ItemStack> arraylist = new ArrayList<>();
@@ -742,8 +739,8 @@ public class ServerPacketHandler extends PacketHandler
     @Override
     public void handleTransaction(ContainerAckPacket packet)
     {
-        Short short1 = (Short) field_10_k.get(Integer.valueOf(playerEntity.craftingInventory.containerId));
-        if (short1 != null && packet.shortWindowId == short1.shortValue() && playerEntity.craftingInventory.containerId == packet.windowId && !playerEntity.craftingInventory.isSynched(playerEntity))
+        Short short1 = guiIdMap.get(playerEntity.craftingInventory.containerId);
+        if (short1 != null && packet.shortWindowId == short1 && playerEntity.craftingInventory.containerId == packet.windowId && !playerEntity.craftingInventory.isSynched(playerEntity))
         {
             playerEntity.craftingInventory.setSynched(playerEntity, true);
         }
@@ -756,13 +753,13 @@ public class ServerPacketHandler extends PacketHandler
         WorldServer worldserver = mcServer.getDimensionWorld(playerEntity.dimension);
         if (worldserver.isBlockLoaded(packet.xPosition, packet.yPosition, packet.zPosition))
         {
-            BlockEntity tileentity = worldserver.getBlockEntity(packet.xPosition, packet.yPosition, packet.zPosition);
-            if (tileentity instanceof SignBlockEntity)
+            BlockEntity blockEntity = worldserver.getBlockEntity(packet.xPosition, packet.yPosition, packet.zPosition);
+            if (blockEntity instanceof SignBlockEntity)
             {
-                SignBlockEntity tileentitysign = (SignBlockEntity) tileentity;
-                if (!tileentitysign.isEditableBy(playerEntity))
+                SignBlockEntity sign = (SignBlockEntity) blockEntity;
+                if (!sign.isEditableBy(playerEntity))
                 {
-                    mcServer.logWarning("Player " + playerEntity.username + " just tried to change non-editable sign");
+                    LOGGER.warn("Player {} just tried to change non-editable sign", playerEntity.username);
                     return;
                 }
             }
@@ -775,7 +772,7 @@ public class ServerPacketHandler extends PacketHandler
                 }
                 else
                 {
-                    packet.signLines[i] = packet.signLines[i].replaceAll("\u00A7", "$");
+                    packet.signLines[i] = packet.signLines[i].replaceAll("§", "$");
                     for (int l = 0; l < packet.signLines[i].length(); l++)
                     {
                         if (ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(packet.signLines[i].charAt(l)) < 0)
@@ -791,16 +788,13 @@ public class ServerPacketHandler extends PacketHandler
                 }
             }
 
-            if (tileentity instanceof SignBlockEntity)
+            if (blockEntity instanceof SignBlockEntity)
             {
                 int x = packet.xPosition;
                 int y = packet.yPosition;
                 int z = packet.zPosition;
-                SignBlockEntity tileEntity = (SignBlockEntity) tileentity;
-                for (int j1 = 0; j1 < 4; j1++)
-                {
-                    tileEntity.signText[j1] = packet.signLines[j1];
-                }
+                SignBlockEntity tileEntity = (SignBlockEntity) blockEntity;
+                System.arraycopy(packet.signLines, 0, tileEntity.signText, 0, 4);
 
                 tileEntity.setColor(TextFormatting.FORMATTINGS[packet.color]);
                 tileEntity.setPicture(EnumSignPicture.values()[packet.picture]);
@@ -852,18 +846,18 @@ public class ServerPacketHandler extends PacketHandler
     	}else if("BTA|Flag".equals(packet.channel)) {
     		if(packet.data.length == 24 * 16 && playerEntity.craftingInventory instanceof FlagMenu) {
     			FlagMenu flagMenu = (FlagMenu) playerEntity.craftingInventory;
-    			FlagBlockEntity tileEntity = flagMenu.flag;
-    			
-    			if(tileEntity.owner == null || tileEntity.owner.isEmpty() || tileEntity.owner.equals(playerEntity.username)) {
-        			tileEntity.owner = playerEntity.username;
-        			System.arraycopy(packet.data, 0, tileEntity.flagColors, 0, 24 * 16);
-        			
-        			playerEntity.world.markBlockNeedsUpdate(tileEntity.x, tileEntity.y, tileEntity.z);
+    			FlagBlockEntity flag = flagMenu.flag;
+
+    			if(flag.owner == null || flag.owner.equals(playerEntity.uuid)) {
+                    flag.owner = playerEntity.uuid;
+        			System.arraycopy(packet.data, 0, flag.flagColors, 0, 24 * 16);
+
+        			playerEntity.world.markBlockNeedsUpdate(flag.x, flag.y, flag.z);
     			}else {
-    				System.out.println("Player '" + playerEntity.username + "' tried editing a flag that belongs to '" + tileEntity.owner + "'!");
-    				
+                    LOGGER.warn("Player '{}' tried editing a flag that belongs to '{}'!", playerEntity.username, flag.owner);
+
     				// Let the client know that the flag design has been rejected
-    				playerEntity.world.markBlockNeedsUpdate(tileEntity.x, tileEntity.y, tileEntity.z);
+    				playerEntity.world.markBlockNeedsUpdate(flag.x, flag.y, flag.z);
     			}
     		}
     	} else if ("BTA|WandMonster".equals(packet.channel)) {
@@ -881,10 +875,10 @@ public class ServerPacketHandler extends PacketHandler
     }
 
 
-    public static Logger logger = Logger.getLogger("Minecraft");
+    public static Logger LOGGER = LogUtils.getLogger();
     public NetworkManager netManager;
     public boolean connectionClosed;
-    private MinecraftServer mcServer;
+    private final MinecraftServer mcServer;
     private ServerPlayer playerEntity;
     private int field_15_f;
     private int field_22004_g;
@@ -894,6 +888,6 @@ public class ServerPacketHandler extends PacketHandler
     private double lastPosY;
     private double lastPosZ;
     private boolean hasMoved;
-    private final Map<Integer, Short> field_10_k;
+    private final Map<Integer, Short> guiIdMap;
 
 }
